' Defekte Titel lschen
'
' Das Skript lscht aus einer Selektion alle Titel, deren
' Mediendaten nicht mehr vorhanden sind und deshalb
' in iTunes ein Ausrufungszeichen vor dem Titel anzeigen.
'
' (c) 2007-2015 Gerald Erdmann
'
' Skript aus dem Buch "iPod + iTunes", erscheinen bei O'Reilly
' Weitere Details finden Sie unter http://www.ipodbuch.de.
' Fr etwaige Fehler oder Datenverluste wird keine Garantie
' bernommen. Benutzung auf eigene Gefahr!
'
' Zur Installation das Skript an eine beliebige Stelle kopieren.
' Das Skript kann nicht direkt aus iTunes heraus aufgerufen werden,
' sondern wird direkt aus dem Windows Explorer gestartet.
'
' Version 1.0  Jan. 2007  Erste Version
' Version 1.1  Mar. 2008  Bugfix
' Version 1.2  Sep. 2010  Fix fr iTunes 10
' Version 1.3  Jan. 2015  Fix fr iTunes 12
'

dim iTunes
dim tracklist
dim track
dim brokenTracks ()
dim foundCount
dim deletedCount

set iTunes = CreateObject ("iTunes.Application")
set tracklist = iTunes.SelectedTracks
set iTunesTracks = itunes.LibraryPlaylist.Tracks

redim brokenTracks (iTunesTracks.count)
foundCount = 0

if left (iTunes.Version, 3) <> "10." and left (iTunes.Version, 3) <> "11." and left (iTunes.Version, 3) <> "12." and left (iTunes.Version, 3) <> "13." and iTunes.Version < "4.0" then
  WScript.Echo "Sie bentigen iTunes 4 oder hher fr dieses Skript!"
else
  if tracklist is nothing then
    WScript.Echo "Sie haben keine Titel selektiert!"
  else
    for track = tracklist.Count to 1 step -1
      if tracklist.Item(track).Kind = 1 then
        if tracklist.Item(track).Location = "" then
          foundCount = foundCount + 1
          brokenTracks(foundCount) = tracklist.Item(track).TrackDatabaseID
        end if
      end if
    next

    if foundCount > 0 then
      deletedCount = foundCount
      for track = iTunesTracks.Count to 1 step -1
        for found = 1 to foundCount
          if iTunesTracks.Item(track).TrackDatabaseID = brokenTracks(found) then
            deletedCount = deletedCount  - 1
            iTunesTracks.Item(track).Delete
            exit for
          end if
        next
        if deletedCount = 0 then
          exit for
        end if 
      next
      if foundCount = 1 then
        WSCript.Echo "Es wurde ein defekter Titel gelscht!"
      else
        WScript.Echo "Es wurden " & foundCount & " defekte Titel gelscht!"
      end if
    else
      WScript.Echo "Es wurden keine defekten Titel gefunden!"
    end if
  end if
end if